lds.ui.adView = {};
(function() {

	Ti.API.info('loading adView');
	var ivImages=[];
	var win = null;
	var currentIndex = null;

	lds.ui.adView.setImageList = function(list) {
		ivImages = list;
	};
	function loadViewFromModel() {
		if (Titanium.Platform.displayCaps.dpi == 320) {
			var isHires = true;
		}
		var views = [];
		for (var i = 0, len = ivImages.length; i < len; i++) {
			var img = lds.io.getPathForContentFolder(ivImages[i].id) + '/' + ivImages[i].img;
			var adImg;
			if (Ti.Platform.osname === 'android') {
				adImg = Ti.UI.createWebView({
					html: '<html><head><meta charset="utf-8" /></head><body style="margin:0;padding:0;background-color:#000;border:0;"><img width="1200px" src="' +  img + '"/></body></html>',
					scalesPageToFit:true
				});
				
			} else {
				adImg = Ti.UI.createImageView({
					image:img,
					width:320,
					height:440,
					canScale: true,
					//				opacity:1,
					preventDefaultImage:true
				});
			}
			
			if (Titanium.Platform.name !== 'android') {
				adImg.hires = isHires;
			}
			views[i] = adImg;
		}
		return views;
	}

	function saveToGallery() {
		var f = lds.io.getFile(ivImages[currentIndex].img,ivImages[currentIndex].id);
		Ti.API.info('path to save:' + f.nativePath);
		Titanium.Media.saveToPhotoGallery(f, {
			success: function(e) {
				Titanium.UI.createAlertDialog({
					title: 'Photo Gallery',
					message: 'The image has been saved to your photo gallery.'
				}).show();
			},
			error: function(e) {
				Titanium.UI.createAlertDialog({
					title: 'Error saving',
					message: e.error
				}).show();
			}
		});
	}

	function getIndexForId(id) {
		for (var i = 0; i < ivImages.length; i++) {
			if(ivImages[i].id === id) {
				break;
			}
		}
		return i;
	}

	function getIdForIndex(idx) {
		return ivImages[idx].id;
	}

	lds.ui.adView.show = function(id) {
		if(!g_processingClick) {
			g_processingClick = true;

			win = Ti.UI.createWindow({
				backgroundColor:'#000',
				barColor:'#000',
				title:'Mormonad',
				fullscreen:false,
				orientationModes: [Ti.UI.PORTRAIT]
			});

			win.addEventListener('android:back', function (e) {
//				alert('back');
//				Ti.API.Info("Pressing Back Will Not Close The Activity/Window");
				win.close();
				close_cleanup();
			});
			var closeBtn = Ti.UI.createButton({
				title:'Back'
			});
			closeBtn.addEventListener('click', function(e) {
				win.close();
				close_cleanup();
			});
			var shareBtn = Ti.UI.createButton({
				image:'images/share.png'
			});

			shareBtn.addEventListener('click', function(e) {
				var id = getIdForIndex(currentIndex);
				var asset = lds.io.loadAssetFile(id);
				lds.ui.shareView.showhide(win,closeBtn,shareBtn,asset);
			});
			var isAndroid = Ti.Platform.name === 'android';
			if (!isAndroid) {
				win.leftNavButton = closeBtn;
				win.rightNavButton = shareBtn;
			}
			
			var imageViews = loadViewFromModel();

			var iv = Ti.UI.createScrollableView({
				top: 0,
				backgroundColor:'#222',
				maxZoomScale:2.0,
				showPagingControl:false,
				views: imageViews
			});
			iv.addEventListener('scroll', function(e) {
				currentIndex = e.currentPage;
				Titanium.Analytics.featureEvent('View Mormonad',{id:getIdForIndex(currentIndex)});

			});
			var dialog = Titanium.UI.createOptionDialog({
				options:['Save It', 'Cancel'],
				destructive:1,
				cancel:1,
				title:'Save Image to Photo Gallery'
			});

			// add event listener
			dialog.addEventListener('click', function(e) {
				if (1 !== e.index) {
					saveToGallery();
				}
			});
			iv.addEventListener('singletap', function(e) {
				dialog.show();
			});

			win.add(iv);
			currentIndex = getIndexForId(id);
			iv.currentPage = currentIndex;
			win.open({modal:true});
			
			Titanium.Analytics.featureEvent('View Mormonad',{id:id});
			
			if (isAndroid) {
				lds.ui.shareView.addAndroidMenu(id);
			}
		}
	};
	function close_cleanup() {
		//		win.remove(iv);
//		win.close();
		win = null;
		g_processingClick = false;
	}

})();

