lds.Audio = require('org.lds.audio');

var audioController = function () {
	var playListIndex = 0;
	//	var stopBtn = false;
	var playList;
	var audioPlayer = lds.Audio.createAudioPlayer({allowBackground:true});
					
	audioPlayer.addEventListener('change', playbackStateChange);
	//audioPlayer.addEventListener('progress', progressChange);
	audioPlayer.addEventListener('complete', playComplete);
	//audioPlayer.addEventListener('buffering', songBuffering);

	var gotoNext = true;

	// Need this so that any sound which is playing when we come in continues to
	// do so
	Titanium.Media.audioSessionMode = Ti.Media.AUDIO_SESSION_MODE_PLAYBACK;

	var modeArray = [
	{mode:Ti.Media.AUDIO_SESSION_MODE_AMBIENT,desc:'Ambient Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_SOLO_AMBIENT,desc:'Solo Ambient Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_PLAYBACK,desc:'Playback Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_PLAY_AND_RECORD,desc:'Play and Record Mode'}
	];
	var NO_BTN = 0;
	var START_BTN = 1;
	var STOP_BTN = 2;
	var NEXT_BTN = 3;
	var PREV_BTN = 4;
	var btn_state = NO_BTN;

	function findIndexForSongId(id) {
		for(var i = 0; i < playList.length; i++) {
			if(playList[i].id === id) {
				break;
			}
		}
		return i;
	}

	function setPlayList(list) {
		playList = list;	
		lds.ui.audioView.loadViewFromModel(playList);
	}

	/// public player controls
	function start(idx) {
		Ti.API.info('audioController.start idx:' + idx + ' player.state:' + audioPlayer.state + ' btn_state:' + btn_state);
		Ti.API.info('playListIndex: ' + playListIndex);
		if (true === Titanium.Network.online) {
			if(idx !== playListIndex) {
				endPlay();
				playListIndex = idx;				
			}
			
			if (audioPlayer.state === audioPlayer.STATE_PAUSED) {
				audioPlayer.play();
			} else if(undefined === audioPlayer.state || 
				audioPlayer.STATE_INITIALIZED === audioPlayer.state || 
				audioPlayer.STATE_STOPPED === audioPlayer.state) {
				Ti.API.info('start play ' + idx);
				btn_state = START_BTN;
				beginPlay();
			} else {
				btn_state = START_BTN;
				beginPlay();
			}
			lds.ui.audioView.handleStatusChanges({status:'showImage',idx:playListIndex});
			lds.ui.audioView.handleStatusChanges({status:'cntrlImgChng',state:audioPlayer.state});
		}
	}

	function stop() {
		if (true === Titanium.Network.online) {
			Ti.API.info('stop play pressed');
			Ti.API.info('playListIndex: ' + playListIndex);
			btn_state = STOP_BTN;
			Titanium.App.idleTimerDisabled = false;
			endPlay();
		}
	}

	function pause() {
		if (true === Titanium.Network.online) {
			Ti.API.info('pause player');
			audioPlayer.pause();
			lds.ui.audioView.handleStatusChanges({status:'showImage',idx:playListIndex});
		}
	}

	function next() {
		if (true === Titanium.Network.online) {
			Ti.API.info('play next');
			btn_state = NEXT_BTN;
			nextPlay();
		}
	}

	function prev() {
		if (true === Titanium.Network.online) {
			Ti.API.info('play prev');
			btn_state = PREV_BTN;
			prevPlay();
		}
	}

	// end of public player controls
	function beginPlay() {
		Ti.API.info('playListIndex: ' + playListIndex);
		var url = playList[playListIndex].url;
		url += ( -1 < url.indexOf('?') ) ? '&cid=' : '?cid=';
		url += Titanium.Platform.osname;
		Ti.API.info('Setting URL: ' + url);
		audioPlayer.setUrl(url);
		audioPlayer.play();
		Titanium.App.idleTimerDisabled = true;
		btn_state = NO_BTN;
		Titanium.Analytics.featureEvent('Play Audio',{id:playList[playListIndex].id});
	}

	function endPlay() {
		Ti.API.info('endPlay called');
		Ti.API.info('playListIndex: ' + playListIndex);
		audioPlayer.stop();
	}

	function nextPlay() {
		playListIndex++;
		if(playList.length <= playListIndex) {
			playListIndex = 0;
		}
		Ti.API.info('playListIndex: ' + playListIndex);
		endPlay();
		start(playListIndex);
	}

	function prevPlay() {
		if(--playListIndex < 0) {
			playListIndex = playList.length - 1;
		}
		Ti.API.info('playListIndex: ' + playListIndex);
		endPlay();
		start(playListIndex);
	}
	
	function playComplete(e) {
		Ti.API.info('Audio play complete');
		nextPlay();
	}

	function playbackStateChange(e) {
		Ti.API.info('playbackStateChange Player State:' + audioPlayer.state + ' event state:' + e.state + ' btn state:' + btn_state);
		e.status = 'cntrlImgChng';
		lds.ui.audioView.handleStatusChanges(e);
	}

	function getIndex() {
		return playListIndex;
	}

	function getSongObjAt(index) {
		return playList[index];
	}

	function state() {
		return audioPlayer.state;
	}

	var player = Ti.Media.createAudioPlayer();
	return {
		setPlayList:setPlayList,
		findIndexForSongId:findIndexForSongId,
		state:state,
		getIndex:getIndex,
		getSongObjAt:getSongObjAt,
		start:start,
		stop:stop,
		pause:pause,
		next:next,
		prev:prev,
		BUFFERING:player.STATE_BUFFERING,
		INITIALIZED:player.STATE_INITIALIZED,
		PAUSED:player.STATE_PAUSED,
		PLAYING:player.STATE_PLAYING,
		STARTING:player.STATE_STARTING,
		STOPPING:player.STATE_STOPPING,
		STOPPED:player.STATE_STOPPED,
		WAITING_FOR_DATA:player.STATE_WAITING_FOR_DATA,
		WAITING_FOR_QUEUE:player.STATE_WAITING_FOR_QUEUE
	};
}();