var audioController = function () {
	var playListIndex = 0;
	//	var stopBtn = false;
	var playList;

	// Need this so that any sound which is playing when we come in continues to
	// do so
	Titanium.Media.audioSessionMode = Ti.Media.AUDIO_SESSION_MODE_PLAYBACK;

	var modeArray = [
	{mode:Ti.Media.AUDIO_SESSION_MODE_AMBIENT,desc:'Ambient Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_SOLO_AMBIENT,desc:'Solo Ambient Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_PLAYBACK,desc:'Playback Mode'},
	{mode:Ti.Media.AUDIO_SESSION_MODE_PLAY_AND_RECORD,desc:'Play and Record Mode'}
	];
	var NO_BTN = 0;
	var START_BTN = 1;
	var STOP_BTN = 2;
	var NEXT_BTN = 3;
	var PREV_BTN = 4;
	var btn_state = NO_BTN;

	var player = Ti.Media.createAudioPlayer();

	function findIndexForSongId(id) {
		for(var i = 0; i < playList.length; i++) {
			if(playList[i].id === id) {
				break;
			}
		}
		return i;
	}

	function setPlayList(list) {
		playList = list;
		lds.ui.audioView.loadViewFromModel(playList);
	}

	/// public player controls
	var STRTING = 1;
	var PLAYING = 4;
	var PAUSED = 8;

	function start(idx) {
		if (true === Titanium.Network.online) {
			if(undefined === idx) {
				if(0 === player.state) {
					Ti.API.info('start play');
					btn_state = NO_BTN;
					beginPlay();
				} else {
					lds.ui.audioView.handleStatusChanges({
						status:'showImage',
						idx:playListIndex
					});
				}
			} else {
				if(0 === player.state) {
					Ti.API.info('start play' + idx);
					playListIndex = idx;
					btn_state = START_BTN;
					beginPlay();
				} else {
					if(idx !== playListIndex || PAUSED === player.state) {
						playListIndex = idx;
						btn_state = START_BTN;
						endPlay();
					} else {
						lds.ui.audioView.handleStatusChanges({
							status:'showImage',
							idx:playListIndex
						});
					}
				}
			}
		}
	}

	function stop() {
		if (true === Titanium.Network.online) {
			Ti.API.info('stop play pressed');
			btn_state = STOP_BTN;
			endPlay();
		}
	}

	function pause() {
		if (true === Titanium.Network.online) {
			player.pause();
			lds.ui.audioView.handleStatusChanges({
				status:'showImage',
				idx:playListIndex
			});
		}
	}

	function next() {
		if (true === Titanium.Network.online) {
			Ti.API.info('play next');
			btn_state = NEXT_BTN;
			nextPlay();
		}
	}

	function prev() {
		if (true === Titanium.Network.online) {
			Ti.API.info('play prev');
			btn_state = PREV_BTN;
			prevPlay();
		}
	}

	// end of public player controls
	function beginPlay() {
		var url = playList[playListIndex].url;
		url += ( -1 < url.indexOf('?') ) ? '&cid=' : '?cid=';
		url += Titanium.Platform.osname;
		player.setUrl(url);
		Ti.API.info('playing :' + url);
		player.start();
		Titanium.App.idleTimerDisabled = true;
		btn_state = NO_BTN;
		lds.ui.audioView.handleStatusChanges({
			status:'showImage',
			idx:playListIndex
		});
		Titanium.Analytics.featureEvent('Play Audio',{id:playList[playListIndex].id});

	}

	function endPlay() {
		player.stop();
	}

	function nextPlay() {
		playListIndex++;
		if(playList.length <= playListIndex) {
			playListIndex = 0;
		}
		if (btn_state === NO_BTN) {
			start();
		} else {
			endPlay();
		}
	}

	function prevPlay() {
		if(--playListIndex < 0) {
			playListIndex = playList.length - 1;
		}
		if (btn_state === NO_BTN) {
			start();
		} else {
			endPlay();
		}
	}

	//  player state and progress callbacks
	function playbackProgress(e) {
		//        Ti.API.info(e.progress);
	}

	function playbackStateChange(e) {
		Ti.API.info('State =:' + e.state);
		if (e.state === 0) {
			if (NEXT_BTN === btn_state || PREV_BTN === btn_state || START_BTN === btn_state) {
				Ti.API.info('Next Pressed playing next or prev or start another');
				beginPlay();
			} else if (NO_BTN === btn_state ) { //this means the current song ended, so start the next one
				Ti.API.info('song ended playing next');
				nextPlay();
			} else if (STOP_BTN === btn_state) {
				Titanium.App.idleTimerDisabled = false;
			}
		}
		e.status = 'cntrlImgChng';
		lds.ui.audioView.handleStatusChanges(e);
	}

	player.addEventListener('change', playbackStateChange);
	player.addEventListener('progress', playbackProgress);

	function getIndex() {
		return playListIndex;
	}

	function getSongObjAt(index) {
		return playList[index];
	}

	function state() {
		return player.state;
	}

	return {
		setPlayList:setPlayList,
		findIndexForSongId:findIndexForSongId,
		state:state,
		getIndex:getIndex,
		getSongObjAt:getSongObjAt,
		start:start,
		stop:stop,
		pause:pause,
		next:next,
		prev:prev,
		BUFFERING:player.STATE_BUFFERING,
		INITIALIZED:player.STATE_INITIALIZED,
		PAUSED:player.STATE_PAUSED,
		PLAYING:player.STATE_PLAYING,
		STARTING:player.STATE_STARTING,
		STOPPING:player.STATE_STOPPING,
		STOPPED:player.STATE_STOPPED,
		WAITING_FOR_DATA:player.STATE_WAITING_FOR_DATA,
		WAITING_FOR_QUEUE:player.STATE_WAITING_FOR_QUEUE
	};
}();