lds.ui.audioView = {};
(function() {

	Ti.API.info('loading audioView');
	var cvImages=[];
	var win = null;
	var cv,songTitle,songAuth,playpauseAudio,loadingView;

	function selectedIndex() {
		if (Ti.Platform.osname === 'android') {
			return cv.currentPage;
		} else {
			return cv.selected;
		}
	}

	function createViews(win) {
		var closeBtn = Ti.UI.createButton({
			title:'Back'
		});
		closeBtn.addEventListener('click', function(e) {
			lds.ui.audioView.hide();
		});
		var aBtn = Ti.UI.createButton({
			image:'images/share.png'
		});
		aBtn.addEventListener('click', function(e) {
			var s = audioController.getSongObjAt(audioController.getIndex());
			var obj = lds.io.loadAssetFile(s.id);
			lds.ui.shareView.showhide(win,closeBtn,aBtn,obj);
		});
		loadingView = createLoadingView();
		createCoverFlow();
		
		var isAndroid = Titanium.Platform.name === 'android';
		songTitle = Ti.UI.createLabel({
			font:{fontSize:16, fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			top: 295,
			width:Titanium.Platform.displayCaps.platformWidth,
			height:'auto',
			textAlign:'center'
		});
		songAuth = Ti.UI.createLabel({
			font:{fontSize:12, fontstyle:'italic'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			top: 318,
			width:Titanium.Platform.displayCaps.platformWidth,
			height:'auto',
			textAlign:'center'
		});

		playpauseAudio = Titanium.UI.createButton({
			backgroundImage:'images/pausebtn.png',
			bottom:28,
			left:Titanium.Platform.displayCaps.platformWidth/2-16,
			width:38,
			height:38
		});
		playpauseAudio.addEventListener('click', function() {
			handlePlayPauseClick();
		});
		var prev = Titanium.UI.createButton({
			backgroundImage:'images/prevbtn.png',
			bottom:28,
			left:Titanium.Platform.displayCaps.platformWidth/2-(19+90),
			width:38,
			height:38
		});
		prev.addEventListener('click', function() {
			showLoading();
			audioController.prev();
		});
		var next = Titanium.UI.createButton({
			backgroundImage:'images/nextbtn.png',
			bottom:28,
			left:Titanium.Platform.displayCaps.platformWidth/2+(90-19),
			width:38,
			height:38
		});
		next.addEventListener('click', function() {
			showLoading();
			audioController.next();
		});
		win.leftNavButton = closeBtn;
		win.rightNavButton = aBtn;
		win.add(cv);
		win.add(songTitle);
		win.add(songAuth);
		win.add(playpauseAudio);
		win.add(prev);
		win.add(next);
	}

	function createLoadingView()
	{
		var view = Ti.UI.createView({
			backgroundColor: '#333',
			opacity: 0.5
		});
		
		var label = Ti.UI.createLabel({
			color:'#fff',
			text: 'Loading song...',
			font:{fontSize:26, fontWeight:'bold'},
		});
		
		view.add(label);
		
		return view;
	}
	
	function showLoading() {
		win.add(loadingView);
	}

	function createCoverFlow()
	{
		if (Titanium.Platform.name === 'android')
		{			
			var imageViews = [];
			for (var i=0,len = cvImages.length; i < len; i++) {
				var imageView = Ti.UI.createImageView({
					width:320,
					height:280,
					image:cvImages[i],
					index: i
				});
				imageView.addEventListener('click', function(e) {
					//if(e.index === e.previous) {
						//			alert(e.index);
						Ti.API.info('imageView clicked index: ' + e.source.index);
						handlePlayPauseClick(e.source.index);
					//}
				});	
				
				imageViews[i] = imageView;
			};
			
			cv = Titanium.UI.createScrollableView({
				top:0,
				left:0,
				height:280,
				backgroundColor:'#222',
				pagingControlHeight:20,
				maxZoomScale:2.0,
				showPagingControl:true,
				views:imageViews
			});
			cv.addEventListener('scroll', function(e) {
				Ti.API.info('scroll event e.currentPage:' + e.currentPage);
				updateSongInfo(e.currentPage);
			});
		}
		else // iphone or ipad
		{
			cv = Titanium.UI.createCoverFlowView({
				top:0,
				width:320,
				height:280,
				backgroundColor:'#000',
				images:cvImages
			});
			cv.addEventListener('change', function(e) {
				updateSongInfo(e.index);
			});
			cv.addEventListener('click', function(e) {
				if(e.index === e.previous) {
					//			alert(e.index);
					handlePlayPauseClick(e.index);
				}
			});			
		}
	}

	function updateControlState(val) {
		Ti.API.info('updateControlState val:' + val);
		if(val == audioController.STARTING || val == audioController.WAITING_FOR_DATA || val == audioController.WAITING_FOR_QUEUE || val == audioController.PLAYING) {
			playpauseAudio.backgroundImage = 'images/pausebtn.png';
		} else if (val === audioController.PAUSED) {
			playpauseAudio.backgroundImage = 'images/playbtn.png';
		} else {		// must be STOPPED
			playpauseAudio.backgroundImage = 'images/playbtn.png';
		}
		Ti.App.idleTimerDisabled = true;
	}

	function handlePlayPauseClick(idx) {
		var val = audioController.state();
		var index = audioController.getIndex();
		Ti.API.info('handlePlayPauseClick state:' + val + ' idx:' + idx + ' index:' + index + ' selectedIndex:' + selectedIndex())
		
		if (undefined === idx || index === idx){
			// play pause button clicked
			if (val === audioController.PLAYING) {
				audioController.pause();
			} else {
				audioController.start(selectedIndex());	
			}
		}
		else if (index != idx){
			showLoading();
			audioController.start(idx);			
		}
	}

	function updateSongInfo(index) {
		Ti.API.info('updateSongInfo selected:' + selectedIndex() + ' new index:' + index);
		if (index !== selectedIndex()) {
			if (Ti.Platform.name === 'android') {
				cv.currentPage = index;
			} else {
				cv.selected = index;
			}
		}
		
		var obj = audioController.getSongObjAt(index);
		songTitle.text = obj.title;
		songAuth.text = obj.author[0];
	}

	lds.ui.audioView.loadViewFromModel = function(a) {
		for (var i = 0, len = a.length; i < len; i++) {
			cvImages[i] = lds.io.getPathForContentFolder(a[i].id) + '/' + a[i].img;
			var file = Ti.Filesystem.getFile(cvImages[i]);
			if (file.exists() == false) {
				cvImages[i] = 'images/large-placeholder.png';
			}
			Ti.API.info(cvImages[i]);
		}
		//		cv.images = cvImages;
	};
	lds.ui.audioView.handleStatusChanges = function(e) {
		if (null !== win) { // window might be closed so check and skip updates
			switch(e.status) {
				case 'showImage':
					updateSongInfo(e.idx);
					win.remove(loadingView);
					break;
				case 'cntrlImgChng':
					updateControlState(e.state);
					break;
				default:

					break;
			}
		}
	};
	lds.ui.audioView.show = function(id) {
		if(!g_processingClick) {
			g_processingClick = true;
			if (false === Titanium.Network.online) {
				Titanium.UI.createAlertDialog({
					title:'Internet Connection',
					message: 'Listening to music requires a connection to the Internet.',
					buttonNames: ['OK']
				}).show();
				g_processingClick = false;
				return;
			}

			win = Ti.UI.createWindow({
				backgroundColor:'#000',
				barColor:'#000',
				title:'Audio',
				fullscreen:false
			});
			win.addEventListener('android:back', function (e) {
				lds.ui.audioView.hide();
			});
			
			createViews(win);

			var curSongIndex;
			if (undefined === id) {
				curSongIndex = audioController.getIndex();
			} else {
				curSongIndex = audioController.findIndexForSongId(id);
			}
			updateSongInfo(curSongIndex);
			win.open({modal:true});
			showLoading();
			audioController.start(curSongIndex);
		}
	};
	lds.ui.audioView.hide = function() {
		win.remove(cv);
		win.close();
		win = null;
		g_processingClick = false;
	};
})();
