var downLoadMgr = function() {
	//var FEED_URL = 'http://192.168.1.33/resources/v1?format=json&locale=eng&lang=eng&sinceUtc=';
	var FEED_URL = 'http://wsmobile1.lds.org/Youth/resources/v1?format=json&locale=eng&lang=eng&sinceUtc=';
	//var FEED_URL = 'http://10.118.197.194/resources/v1?format=json&locale=eng&lang=eng&sinceUtc=';

	var mType = {
		FEATURE_TYPE 	: 'Feature',
		VIDEO_TYPE 		: 'Video',
		ARTICLE_TYPE 	: 'Article',
		AUDIO_TYPE 		: 'Audio',
		MORMONAD_TYPE 	: 'Mormonad',
		RETRY_LIST		: 'Retry'
	};

	Ti.App.addEventListener('asset_down', function() {
		downloadAssetInQueue_async();
		
		var tot = download_total * 2;
		var count = download_total - g_download_queue.length;
		lds.ui.pleaseWait.setProg(tot,count);
	});
	var g_download_queue = [];
	var download_total = 0;
	var failed_queue = [];
	function downloadAssetInQueue_async () {
		if (0 < g_download_queue.length) {
			var qObject = g_download_queue.pop();
			var image = qObject.url;
			var folder = qObject.id;
			imgName = image.substring(image.lastIndexOf('/') + 1, image.length);
			lds.net.get_remote_file('remoteonly',imgName, folder, image, function(f) {
				if(f.error !== undefined && f.error != null) {
					(undefined === qObject.cnt) ? (qObject.cnt = 1) : (qObject.cnt+=1);
					Ti.API.info('error:' + f.error);
					Ti.API.info('pushing error obj');
					if ( qObject.cnt <= 5 ) {
						failed_queue.push(qObject);
					}
				}
				Ti.App.fireEvent('asset_down');
			}, null );
		} else {
			lds.io.saveTypeListFile(mType.RETRY_LIST,failed_queue);
			hidePleaseWait();
			Ti.App.fireEvent('download_done');
		}
	}

	function appendRetryUrisToDownloadQueue(obj) {
		for (var i = 0; i < obj.length; i++) {
			g_download_queue.push(obj[i]);
		}
	}

	function appendAssetUrisToDownloadQueue(obj) {
		var id = obj.ResourceId;
		var assets = obj.AssetUris;
		var a_count = assets.length;
		if ( 0 < a_count ) {
			for (var i=0; i < a_count; i++) {
				var url = assets[i];
				if(url !== "") {
					if(mType.MORMONAD_TYPE === obj.ResourceType) {
						// uri1 and uri2 are the images that we are NOT going to download
						var uri1 = obj.LargeImageUri;
						var uri2 = (Titanium.Platform.displayCaps.dpi == 320) ? obj.SmallImageUri : obj.Source;
						if (Ti.Platform.osname === 'android') {
							uri2 = obj.SmallImageUri;
						}
						if(!obj.IsFeatured) {
							if(url.indexOf(uri1) === -1 && url.indexOf(uri2) === -1) {
								g_download_queue.push({
									url:url,
									id:id});
							}
						} else {
							if(url.indexOf(uri2) === -1) {
								g_download_queue.push({
									url:url,
									id:id});
							}
						}
					} else if (mType.AUDIO_TYPE === obj.ResourceType) {
						var x2x = '@2x.';
						if(url.indexOf(x2x) === -1) {
							g_download_queue.push({
								url:url,
								id:id});
						}
						/*					} else if (ARTICLE_TYPE === obj.ResourceType || VIDEO_TYPE === obj.ResourceType){
 						var smUri = obj.SmallImageUri;
 						if(url.indexOf(smUri) === -1){
 						g_download_queue.push({
 						url:url,
 						id:id});
 						}*/
					} else {
						g_download_queue.push({
							url:url,
							id:id});
					}
				}
			}
		}
	}

	var g_fList,g_vList,g_arList,g_auList,g_mList;
	function openRibbonLists() {
		g_fList = lds.io.openTypeListFile(mType.FEATURE_TYPE);
		g_vList = lds.io.openTypeListFile(mType.VIDEO_TYPE);
		g_arList = lds.io.openTypeListFile(mType.ARTICLE_TYPE);
		g_auList = lds.io.openTypeListFile(mType.AUDIO_TYPE);
		g_mList = lds.io.openTypeListFile(mType.MORMONAD_TYPE);
	}

	function saveRibbonLists() {
		lds.io.saveTypeListFile(mType.FEATURE_TYPE,g_fList);
		lds.io.saveTypeListFile(mType.VIDEO_TYPE,g_vList);
		lds.io.saveTypeListFile(mType.ARTICLE_TYPE,g_arList);
		lds.io.saveTypeListFile(mType.AUDIO_TYPE,g_auList);
		lds.io.saveTypeListFile(mType.MORMONAD_TYPE,g_mList);
	}

	function sortByDisplayOrder(a, b) {
		var x = a.order;
		var y = b.order;
		return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	}

	function orderRibbonLists() {
		g_fList.sort(sortByDisplayOrder);
		g_vList.sort(sortByDisplayOrder);
		g_arList.sort(sortByDisplayOrder);
		g_auList.sort(sortByDisplayOrder);
		g_mList.sort(sortByDisplayOrder);
	}

	function addToFeatureList(cur_feed) {
		var isUpdate = false;
		var x = 0;
		for (x = 0; x < g_fList.length; x++) {//check to see if we just need to update the information
			if(cur_feed.ResourceId === g_fList[x].id) {
				isUpdate = true;
				break;
			}
		}
		if (isUpdate) {
			g_fList[x].id = cur_feed.ResourceId;
			g_fList[x].title = cur_feed.Title;
			g_fList[x].isfeature = cur_feed.IsFeatured;
			g_fList[x].thumb = cur_feed.LargeImageUri;
			g_fList[x].type = cur_feed.ResourceType;
			g_fList[x].order = cur_feed.DisplayOrder;
			g_fList[x].isVisible = true;
		} else {
			g_fList.push({
				id:cur_feed.ResourceId,
				title: cur_feed.Title,
				isfeature:cur_feed.IsFeatured,
				thumb:cur_feed.LargeImageUri,
				type: cur_feed.ResourceType,
				order: cur_feed.DisplayOrder,
				isVisible:true
			});
		}
	}

	function addToTypeList(cur_feed,list) {
		var isUpdate = false;
		var x = 0;
		for (x = 0; x < list.length; x++) {//check to see if we just need to update the information
			if(cur_feed.ResourceId === list[x].id) {
				isUpdate = true;
				break;
			}
		}
		var vis = true;
		if ( cur_feed.IsFeatured ) {
			vis = false;
		}
		var _img = cur_feed.SmallImageUri;

		if (cur_feed.ResourceType === mType.MORMONAD_TYPE && (Titanium.Platform.displayCaps.dpi == 320 || Ti.Platform.osname === 'android')) {
			_img = cur_feed.Source;
		}
		if (isUpdate) {
			list[x].id = cur_feed.ResourceId;
			list[x].title = cur_feed.Title;
			list[x].isfeature = cur_feed.IsFeatured;
			list[x].thumb = cur_feed.MediumImageUri;
			list[x].type = cur_feed.ResourceType;
			list[x].order = cur_feed.DisplayOrder;
			list[x].isVisible = vis;

			list[x].author = cur_feed.Authors;
			list[x].img = _img;
			list[x].url = cur_feed.AudioUri;
		} else {
			list.push({
				id:cur_feed.ResourceId,
				title: cur_feed.Title,
				isfeature:cur_feed.IsFeatured,
				thumb:cur_feed.MediumImageUri,
				type: cur_feed.ResourceType,
				order: cur_feed.DisplayOrder,
				isVisible: vis,

				author:cur_feed.Authors,
				img:_img,
				url:cur_feed.AudioUri
			});
		}
	}

	function deleteFromList(id, list) {
		Ti.API.info('Delete Item From List :' + id);
		for (var x = 0; x < list.length; x++) {
			//			Ti.API.info('in delete of item from list' + x + ' len:' + list.length);
			if(id === list[x].id) {
				break;
			}
		}
		if(x !== list.length) {
			Ti.API.info('DELETE of article');
			list.splice(x,1);
		}
	}

	function fixContentUriForLocalAccess(obj) {
		var artPath = lds.io.getPathForContentFolder(obj.ResourceId);
		obj.Content = obj.Content.replace(/####/g, artPath + "/");
	}

	function processResourceStream(resource_array) {
		var r_count = resource_array.length;
		openRibbonLists();
		//		if(null === index) { index = []; }
		Ti.API.info('Articles in feed:' + r_count);
		for (var r=0; r < r_count; r++) {
			var cur_feed = resource_array[r];
			Ti.API.info('feed data:' + JSON.stringify(cur_feed));
			if(cur_feed.ResourceStatus === "Published") {//add new items to proper list and queue assets for download
				fixContentUriForLocalAccess(cur_feed);
				lds.io.saveAssetFile(cur_feed);
				if(cur_feed.AssetsChanged) {
					appendAssetUrisToDownloadQueue(cur_feed);
				}
				// now add the basic item info to list for Ribbon display
				if(cur_feed.IsFeatured) {// add to feature list and then to the type list
					addToFeatureList(cur_feed);
				} else {//check to see if we need to remove from feature list..might have kept published but no longer featured
					deleteFromList(cur_feed.ResourceId, g_fList);
				}
				var list;
				var error= false;
				switch (cur_feed.ResourceType) {
					case mType.VIDEO_TYPE:
						list = g_vList;
						break;
					case mType.ARTICLE_TYPE:
						list = g_arList;
						break;
					case mType.AUDIO_TYPE:
						list = g_auList;
						break;
					case mType.MORMONAD_TYPE:
						list = g_mList;
						break;
					default:
						error = true;
						break;
				}
				if(!error) {
					addToTypeList(cur_feed,list);
				} else {
					Ti.API.info('error in processResourceStream');
				}
			} else { // delete this article from the proper list and then remove asset files from device
				deleteFromList(cur_feed.ResourceId,g_fList);
				var list;
				var error = false;
				switch (cur_feed.ResourceType) {
					case mType.VIDEO_TYPE:
						list = g_vList;
						break;
					case mType.ARTICLE_TYPE:
						list = g_arList;
						break;
					case mType.AUDIO_TYPE:
						list = g_auList;
						break;
					case mType.MORMONAD_TYPE:
						list = g_mList;
						break;
					default:
						error = true;
						break;
				}
				if(!error) {
					deleteFromList(cur_feed.ResourceId, list);
				}
				lds.io.deleteContentFolder(cur_feed.ResourceId);
			}
		}
		orderRibbonLists();
		saveRibbonLists();

		g_fList = null;
		g_vList=null;
		g_arList=null;
		g_auList=null;
		g_mList=null;
	}

	function checkForNewContent( fn_end ) {
		if ( Titanium.Network.online === true ) {
			var url = FEED_URL;
			var sinceUtc = Ti.App.Properties.getString('sinceUtc');
			if(null !== sinceUtc) {
				url = url + sinceUtc;
			}

			var xhr = Titanium.Network.createHTTPClient();
			xhr.setTimeout(3000);
			xhr.onload = function() {
				var doc = JSON.parse(this.responseData);
				Ti.API.info('new content:' + doc.Resources.length);
				if(0 < doc.Resources.length) {
					fn_end(true);
				}
			};
			// open the client
			xhr.open('GET',url);
			// send the data
			xhr.send();
		}
	}

	function downloadJSONFeed(sinceUtc, fn_end ) {
		var url = FEED_URL;
		if(null !== sinceUtc) {
			url = url + sinceUtc;
		}
		lds.net.get_remote_file('remoteonly', 'all.json', null, url, fn_end, null);
	}
	
	function hidePleaseWait() {
		setTimeout(function() { lds.ui.pleaseWait.hide(); }, 200);
	}

	function downloadContent() {
		lds.ui.pleaseWait.show('');
		if ( Titanium.Network.online === true ) {
			var sinceUtc = Ti.App.Properties.getString('sinceUtc');
			Ti.API.info("String: "+ sinceUtc );
			var download_errors = 0;

			downloadJSONFeed( sinceUtc, function (f) {
				if ( null != f.error ) {
					download_errors += f.error;
					Ti.API.info('errors downloading content :' + download_errors);
					hidePleaseWait();
					Ti.App.fireEvent('error_downloading');
				}
				if(0 === download_errors) {
					Ti.API.info('got content stream');
					var l_feed = lds.io.openJSONFeed();
					if(l_feed.IsRefresh) {
						lds.io.deleteAllContent();
						Ti.API.info('all content deleted');
					}
					lds.app.sinceUtc = l_feed.CreatedUtc;
					if(undefined != l_feed.Resources && 0 < l_feed.Resources.length) {
						processResourceStream(l_feed.Resources);
						var retry_obj = lds.io.openTypeListFile(mType.RETRY_LIST);
						if(0 < retry_obj.length) {
							appendRetryUrisToDownloadQueue(retry_obj);
							lds.io.deleteTypListFile(mType.RETRY_LIST);
						}
						download_total = g_download_queue.length;
						downloadAssetInQueue_async();
					} else {//nothing to get --- check for retry stuff and get it
						Ti.API.info('Nothing in the feed.');
						var retry_obj = lds.io.openTypeListFile(mType.RETRY_LIST);
						if(0 < retry_obj.length) {
							appendRetryUrisToDownloadQueue(retry_obj);
							lds.io.deleteTypListFile(mType.RETRY_LIST);
							downloadAssetInQueue_async();
						} else {
							hidePleaseWait();
							Ti.App.fireEvent('download_done');
						}
					}
				}
			});
		} else {
			hidePleaseWait();
			Ti.App.fireEvent('error_downloading');
		}
	}

	return{
		downloadContent:downloadContent,
		checkForNewContent:checkForNewContent,
		mType:mType
	};
}();
Ti.include('net.js');
