lds.io = {};
(function() {
	var CONTENT_FOLDER = 'content';

	lds.io.getPathForFile = function(name, folder) {
		if (0 < name.length) {
			var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
			base.createDirectory();
			var d = Titanium.Filesystem.getFile(base.nativePath, folder);
			var f = Titanium.Filesystem.getFile(d.nativePath, name);
			if(f.exists()) {
				return f.nativePath;
			}
		}
		return null;
	};
	lds.io.getFile = function(name, folder) {
		if (0 < name.length) {
			var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
			base.createDirectory();
			var d = Titanium.Filesystem.getFile(base.nativePath, folder);
			var f = Titanium.Filesystem.getFile(d.nativePath, name);
			if(f.exists()) {
				return f;
			}
		}
		return null;
	};
	lds.io.getPathForContentFolder = function(folder) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var d = Titanium.Filesystem.getFile(base.nativePath, folder);
		return d.nativePath;
	};
	lds.io.deleteAllContent = function() {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var d = Titanium.Filesystem.getFile(base.nativePath);

		if(d.exists()) {
			d.deleteDirectory(true);
		}
	};
	lds.io.deleteContentFolder = function(folderName) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var d = Titanium.Filesystem.getFile(base.nativePath,folderName);
		if(d.exists()) {
			d.deleteDirectory(true);
		}
	};
	lds.io.createFolder = function(folderName) {
		var d = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, folderName);
		Ti.API.info('Created ' + folderName + ' dir: ' + d.createDirectory());
		return d;
	};
	lds.io.createContentFolder = function(folderName) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var d = Titanium.Filesystem.getFile(base.nativePath,folderName);
		Ti.API.info('Created ' + folderName + ' dir: ' + d.createDirectory());
		return d;
	};
	lds.io.openTypeListFile = function(type) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var ft = 'error.json';
		switch (type) {
			case downLoadMgr.mType.FEATURE_TYPE:
				ft = 'feature.json';
				break;
			case downLoadMgr.mType.VIDEO_TYPE:
				ft = 'video.json';
				break;
			case downLoadMgr.mType.ARTICLE_TYPE:
				ft = 'article.json';
				break;
			case downLoadMgr.mType.AUDIO_TYPE:
				ft = 'audio.json';
				break;
			case downLoadMgr.mType.MORMONAD_TYPE:
				ft = 'mormonad.json';
				break;
			case downLoadMgr.mType.RETRY_LIST:
				ft = 'retry.json';
				break;
			default:
				break;
		}
		var f = Titanium.Filesystem.getFile(base.nativePath, ft);
		var list;
		if(f.exists()) {
			var file = '' + f.read();
			list = JSON.parse(file);
		} else {
			list = [];
		}
		return list;
	};
	lds.io.saveTypeListFile = function(type,list) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var ft = 'error.json';
		switch (type) {
			case downLoadMgr.mType.FEATURE_TYPE:
				ft = 'feature.json';
				break;
			case downLoadMgr.mType.VIDEO_TYPE:
				ft = 'video.json';
				break;
			case downLoadMgr.mType.ARTICLE_TYPE:
				ft = 'article.json';
				break;
			case downLoadMgr.mType.AUDIO_TYPE:
				ft = 'audio.json';
				break;
			case downLoadMgr.mType.MORMONAD_TYPE:
				ft = 'mormonad.json';
				break;
			case downLoadMgr.mType.RETRY_LIST:
				ft = 'retry.json';
				Ti.API.info('Saving retry');
				break;
			default:
				break;
		}
		var f = Titanium.Filesystem.getFile(base.nativePath, ft);
		var buffer = JSON.stringify(list);
		f.deleteFile();
		if(0 < list.length) {
			Ti.API.info('Saving Type list' + list.length + type);
			f.write(buffer);
		}
	};
	lds.io.deleteTypListFile = function (type) {
		var base = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, CONTENT_FOLDER);
		base.createDirectory();
		var ft = 'error.json';
		switch (type) {
			case downLoadMgr.mType.FEATURE_TYPE:
				ft = 'feature.json';
				break;
			case downLoadMgr.mType.VIDEO_TYPE:
				ft = 'video.json';
				break;
			case downLoadMgr.mType.ARTICLE_TYPE:
				ft = 'article.json';
				break;
			case downLoadMgr.mType.AUDIO_TYPE:
				ft = 'audio.json';
				break;
			case downLoadMgr.mType.MORMONAD_TYPE:
				ft = 'mormonad.json';
				break;
			case downLoadMgr.mType.RETRY_LIST:
				ft = 'retry.json';
				Ti.API.info('Deleting retry');
				break;
			default:
				break;
		}
		var f = Titanium.Filesystem.getFile(base.nativePath, ft);
		f.deleteFile();
	};
	lds.io.saveAssetFile = function(asset_blob) {
		var d = lds.io.createContentFolder(asset_blob.ResourceId);
		var asset_str = JSON.stringify(asset_blob);
		var newFile = Titanium.Filesystem.getFile(d.nativePath,'a.json');
		newFile.deleteFile();
		newFile.write(asset_str);
	};
	lds.io.loadAssetFile = function(asset_id) {
		var d = lds.io.createContentFolder(asset_id);
		var f = Titanium.Filesystem.getFile(d.nativePath, 'a.json');
		var asset;
		if(f.exists()) {
			var file = '' + f.read();
			asset = JSON.parse(file);
		} else {
			asset = null;
		}
		return asset;
	};
	lds.io.openJSONFeed = function() {
		var f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, 'all.json');
		if(f.exists()) {
			var file = '' + f.read();//hack for Android
			var results = JSON.parse(file);
			return results;
		} else {
			alert('oops, file not there. - ');
			return null;
		}
	};
})();

