// - Application Main Window and View setup
//
lds.ui.mainView = {};
(function() {
	var featureScrollView;
	var videoScrollView;
	var articleScrollView;
	var musicScrollView;
	var mormonadScrollView;
	var win;
	var refreshButton;

	lds.ui.mainView.touchEnabled = function(b) {
		win.touchEnabled = b;
	};
	lds.ui.mainView.featureRib = function () {
		return featureScrollView;
	};
	lds.ui.mainView.videoRib = function (obj) {
		return videoScrollView;
	};
	lds.ui.mainView.artRib = function(obj) {
		return articleScrollView;
	};
	lds.ui.mainView.musicRib = function(obj) {
		return musicScrollView;
	};
	lds.ui.mainView.mormonadRib = function(obj) {
		return mormonadScrollView;
	};
	lds.ui.mainView.showRefresh = function() {
		if (Ti.Platform.osname === 'android') {
			refreshButton.setEnabled(true);
		} else {
			win.leftNavButton = refreshButton;
		}
	};
	lds.ui.mainView.createWin = function () {
	
		if (Titanium.Platform.name == 'android') {
			win = Titanium.UI.createWindow({
				title:'LDS Youth',
				backgroundColor:'#000',
				barColor:'#000',
				statusBarhidden:true,
				orientationModes: [
				Titanium.UI.PORTRAIT/*,
				Titanium.UI.LANDSCAPE_LEFT,
				Titanium.UI.UPSIDE_PORTRAIT,
				Titanium.UI.LANDSCAPE_RIGHT*/]
			});
			
			Ti.API.info('add back event listener');
			win.addEventListener('android:back', function(e) {
				Ti.API.info('going back.');
				lds.ui.aboutView.showhide(win);
				return false;
			});	
			
		} else {
			win = Titanium.UI.createWindow({
				title:'LDS Youth',
				backgroundColor:'#000',
				barColor:'#000',
				titleImage:'images/logo.png',
				tabBarHidden:true,
				//			touchEnabled:false,
				orientationModes: [
				Titanium.UI.PORTRAIT/*,
				Titanium.UI.LANDSCAPE_LEFT,
				Titanium.UI.UPSIDE_PORTRAIT,
				Titanium.UI.LANDSCAPE_RIGHT*/]
			});
		}	
	
		if (Titanium.Platform.name !== 'android') {
			refreshButton = Ti.UI.createButton({
				systemButton:Titanium.UI.iPhone.SystemButton.REFRESH
			});
			refreshButton.addEventListener('click', function(e) {
				lds.app.refreshRequested();
				win.leftNavButton = null;
			});
			var iBtn = Titanium.UI.createButton ({
				systemButton: Titanium.UI.iPhone.SystemButton.INFO_LIGHT
			});
			iBtn.addEventListener('click', function() {
				lds.ui.aboutView.showhide(win);
			});
			win.rightNavButton = iBtn;
		}
		else {
			var aboutWindow = Ti.UI.createWindow({
				backgroundColor:'transparent',
				fullscreen:false,
				modal:true
			});
			
			var activity = Ti.Android.currentActivity;
            activity.onCreateOptionsMenu = function (e) {
                var menu = e.menu;
					
				var item1 = menu.add({title: 'About'});
				item1.addEventListener('click', function(){				
					lds.ui.aboutView.showhide(aboutWindow);
					aboutWindow.open();					
				});
				
				refreshButton = menu.add({title: 'Refresh'});
				refreshButton.setEnabled(false);
				refreshButton.addEventListener('click', function(){
					lds.app.refreshRequested();
				});
            }			
		}
		var main_ui_container = Ti.UI.createView({
			top:0,
			left:0,
			height:'auto',
			layout:'vertical'
		});
		/*
 		FEATURE
 		*/
		featureScrollView = Ti.UI.createScrollableView({
			width:320,
			height:195,
			top:0,
			left:0,
			backgroundColor:'#222',
			pagingControlHeight:20,
			maxZoomScale:2.0,
			showPagingControl:true
		});
		main_ui_container.add(featureScrollView);

		/*
 		VIDEOS
 		*/
		videoScrollView = Ti.UI.createScrollView({
			contentWidth:'auto',
			height:125,
			top:0,
			left:0,
			scrollType:'horizontal',
			layout:'horizontal',
			backgroundColor:'#222'
		});
		var videoLabelWrapper = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			height:24
		});
		var videoLabel = Ti.UI.createLabel({
			text:L("videos"),
			font:{fontSize:13, fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			left:10,
			bottom:2,
			height:'auto'
		});
		videoLabelWrapper.add(videoLabel);
		main_ui_container.add(videoLabelWrapper);
		main_ui_container.add(videoScrollView);
		/*
 		ARTICLES
 		*/
		articleScrollView = Ti.UI.createScrollView({
			contentWidth:'auto',
			height:125,
			top:0,
			left:0,
			scrollType:'horizontal',
			layout:'horizontal',
			backgroundColor:'#222'
		});
		var articleLabelWrapper = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			height:24
		});
		var articleLabel = Ti.UI.createLabel({
			text:L("articles"),
			font:{fontSize:13, fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			left:10,
			bottom:2,
			height:'auto'
		});
		articleLabelWrapper.add(articleLabel);
		main_ui_container.add(articleLabelWrapper);
		main_ui_container.add(articleScrollView);
		/*
 		MUSIC
 		*/
		musicScrollView = Ti.UI.createScrollView({
			contentWidth:'auto',
			height:125,
			top:0,
			left:0,
			scrollType:'horizontal',
			layout:'horizontal',
			backgroundColor:'#222'
		});
		var musicLabelWrapper = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			height:24
		});
		var musicLabel = Ti.UI.createLabel({
			text:L('music'),
			font:{fontSize:13, fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			left:10,
			bottom:2,
			height:'auto'
		});
		musicLabelWrapper.add(musicLabel);
		main_ui_container.add(musicLabelWrapper);
		main_ui_container.add(musicScrollView);
		/*
 		MORMONADS
 		*/
		mormonadScrollView = Ti.UI.createScrollView({
			contentWidth:'auto',
			height:155,
			top:0,
			left:0,
			scrollType:'horizontal',
			layout:'horizontal',
			backgroundColor:'#222'
		});
		var mormonadLabelWrapper = Ti.UI.createView({
			top:0,
			left:0,
			right:0,
			height:24
		});
		var mormonadLabel = Ti.UI.createLabel({
			text:L('mormonads'),
			font:{fontSize:13, fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			left:10,
			bottom:2,
			height:'auto'
		});
		mormonadLabelWrapper.add(mormonadLabel);
		main_ui_container.add(mormonadLabelWrapper);
		main_ui_container.add(mormonadScrollView);
		/*
 		END OF MAIN UI OBJECTS
 		*/

		var mainScroll = Ti.UI.createScrollView({
			contentHeight:'auto',
			showVerticalScrollIndicator:true,
			scrollType:'vertical',
			top:0
		});
		mainScroll.add(main_ui_container);
		win.add(mainScroll);

		return win;
	};
})();
/*
Ti.Gesture.addEventListener('orientationchange', function (ev) {
if (Ti.Gesture.isLandscape(ev.orientation)) {
featureScrollView.width = 480;
articleScrollView.width = 480;
videoScrollView.width = 480;
//            musicScrollView.width = 480;
} else {
featureScrollView.width = 320;
articleScrollView.width = 320;
videoScrollView.width = 320;
//            musicScrollView.width = 320;
}
});*/

// - End of UI Setup Section
//
///
