var mainViewLoad = (function() {
	//this var is so that we can delete the views on a refresh
	var featureViews = [];
	
	function removeChildrenFromView(parentObj) {
		var children = parentObj.children;
		if(null !== children) {
			for ( var i = 0; i < children.length; i++ ) {
				var del_child = children[i];
				if (null !== del_child.children) {
					removeChildrenFromView(del_child);
				}
				parentObj.remove(del_child);
				if (Ti.Platform.osname === 'android') {
					del_child.left = 0;
					del_child.right = 0;
					del_child.width = 0;
					del_child.hide();
				}
			}
		}
	}

	function clearUIRibbons() {
		if (lds.app.contentIsLoaded) {
			Ti.API.info('clearing ribbons');

			var len = featureViews.length;
			//			mainView.featureScrollView.hide();
			if (0 < len ) {
				var _view;
				for(var j=0;j<len;j++) {
					_view = featureViews.pop();
					lds.ui.mainView.featureRib().removeView(_view);
					removeChildrenFromView(_view);
				}
			}
			Ti.API.info('feature ribbon cleared');
			var videoChildz = lds.ui.mainView.videoRib().children;
			if (null != videoChildz) {
				removeChildrenFromView(lds.ui.mainView.videoRib());
			}
			Ti.API.info('video ribbon cleared');
			var articleChildz = lds.ui.mainView.artRib().children;
			if (null != articleChildz) {
				removeChildrenFromView(lds.ui.mainView.artRib());
			}
			var musicChildz = lds.ui.mainView.musicRib().children;
			if (null != musicChildz) {
				removeChildrenFromView(lds.ui.mainView.musicRib());
			}
			var adsChildz = lds.ui.mainView.mormonadRib().children;
			if (null != musicChildz) {
				removeChildrenFromView(lds.ui.mainView.mormonadRib());
			}
			lds.app.contentIsLoaded = false;
		}
		loadContentIntoUI();
	}

	var _fList,_vList,_arList,_auList,_mList;
	function openRibbonLists() {
		_fList = lds.io.openTypeListFile(downLoadMgr.mType.FEATURE_TYPE);
		_vList = lds.io.openTypeListFile(downLoadMgr.mType.VIDEO_TYPE);
		_arList = lds.io.openTypeListFile(downLoadMgr.mType.ARTICLE_TYPE);
		_auList = lds.io.openTypeListFile(downLoadMgr.mType.AUDIO_TYPE);
		_mList = lds.io.openTypeListFile(downLoadMgr.mType.MORMONAD_TYPE);			
	}

	function getLargestListLength() {
		var len = _fList.length;
		if(_vList.length > len ) {
			len = _vList.length;
		}
		if(_arList.length > len ) {
			len = _arList.length;
		}
		//		if(_auList.length > len ) { len = _auList.length; }
		//		if(_mList.length > len ) { len = _mList.length; }
		return len;
	}

	function loadContentIntoUI () {
		Ti.API.info('in loadContentIntoUI');
		openRibbonLists();
		audioController.setPlayList(_auList);
		lds.ui.adView.setImageList(_mList);
		var fl = _fList.length;
		var vl = _vList.length;
		var arl = _arList.length;
		var aul = _auList.length;
		var ml = _mList.length;
		Ti.API.info(fl + ' '+ vl + ' ' + arl +' '+ aul + ' ' +ml );

		var totalItems = fl + vl + arl + aul + ml;
		var count = totalItems;
		totalItems = totalItems * 2;
		lds.ui.pleaseWait.setProg(totalItems,count);

		var i, len;
		for (i=0; i < fl; i++) {
			insertResourceIntoRibbon(_fList[i]);
			lds.ui.pleaseWait.setProg(totalItems,++count);
		};
		for (i=0; i < vl; i++) {
			insertResourceIntoRibbon(_vList[i]);
			lds.ui.pleaseWait.setProg(totalItems,++count);
		};
		for (i=0; i < arl; i++) {
			insertResourceIntoRibbon(_arList[i]);
			lds.ui.pleaseWait.setProg(totalItems,++count);
		};
		for (i=0; i < aul; i++) {
			insertResourceIntoRibbon(_auList[i]);
			lds.ui.pleaseWait.setProg(totalItems,++count);
		};
		for (i=0; i < ml; i++) {
			insertResourceIntoRibbon(_mList[i]);
			lds.ui.pleaseWait.setProg(totalItems,++count);
		};

		lds.ui.mainView.artRib().add(Ti.UI.createView({width:5}));
		lds.ui.mainView.musicRib().add(Ti.UI.createView({width:5}));
		lds.ui.mainView.videoRib().add(Ti.UI.createView({width:5}));
		lds.ui.mainView.mormonadRib().add(Ti.UI.createView({width:5}));

		lds.ui.mainView.featureRib().currentPage = 0;
		lds.app.contentIsLoaded = true;
		lds.ui.mainView.touchEnabled(true);
		
		
		
		//var fl = _fList.length;
		//var vl = _vList.length;
		//var arl = _arList.length;
		//var aul = _auList.length;
		//var ml = _mList.length;
		//Ti.API.info(fl + ' '+ vl + ' ' + arl +' '+ aul + ' ' +ml );
		//var len = getLargestListLength();
		//if( 0 !== len || 0 !== aul || 0 !== ml ) {
		//	for(var x=ml-1; x>=0; x--) {
		//		add_2UI_queue.push(_mList[x]);
		//	}
		//	for(var y=aul-1; y>=0; y--) {
		//		add_2UI_queue.push(_auList[y]);
		//	}
		//	for(var i=len-1; i>=0; i--) {
		//		//				if ( i+1 <= aul ) { add_2UI_queue.push(_auList[i]);}
		//		//				if ( i+1 <= ml ) { add_2UI_queue.push(_mList[i]);}
		//		if ( i+1 <= fl ) {
		//			add_2UI_queue.push(_fList[i]);
		//		}
		//		if ( i+1 <= arl ) {
		//			add_2UI_queue.push(_arList[i]);
		//		}
		//		if ( i+1 <= vl ) {
		//			add_2UI_queue.push(_vList[i]);
		//		}
		//	}
		//	processResourceInQueue();
		//} else {
		//	lds.ui.alert('Network Error','Web Service was not found');
		//}
	}

	function makeFeaturedRibbonObj(storyObj) {
		var f1 = lds.io.getPathForFile(storyObj.thumb,storyObj.id);
		if(null === f1) {
			f1 = 'images/large-placeholder.png';
		}
		var imageView = Ti.UI.createImageView({
			image:f1,
			top:0,
			left:0,
			width:320,
			height:174,
			preventDefaultImage:true
		});
		var labelWrapper = Ti.UI.createView({
			left:0,
			top:174-50,
			width:300,
			height:50,
			backgroundColor:'#111111',
			opacity:0.7
		});
		var alabel = Ti.UI.createLabel({
			left:20,
			width:300-20-20,
			height:50,
			text:storyObj.title,
			font:{fontSize:20, fontWeight:'bold'},
			color:'#fff',
			textAlign:'left'
		});
		labelWrapper.add(alabel);
		var ftypeLabelWrap = Ti.UI.createView({
			top:174-50-20,
			left:0,
			width:80,
			height:20,
			backgroundColor:'#111111',
			opacity:0.7
		});
		var ftypeLabel = Ti.UI.createLabel({
			left:20,
			width:60,
			height:20,
			text:storyObj.type,
			font:{fontSize:14, fontWeight:'bold'},
			color:'#E2DABD',
			textAlign:'left'
		});
		ftypeLabelWrap.add(ftypeLabel);
		var viewContainer = Ti.UI.createView({
			height:174,
			width:320,
			backgroundColor:'#000'
		});
		viewContainer.add(imageView);
		viewContainer.add(ftypeLabelWrap);
		viewContainer.add(labelWrapper);
		return viewContainer;
	}

	function makeStandardRibbonObj(storyObj) {
		var f = lds.io.getPathForFile(storyObj.thumb, storyObj.id);
		if(null === f) {
			f = 'images/med-placeholder.png';
		}
		
		var view = Ti.UI.createView({
			top:0,
			left:0,
			width:115,
			height:125,
			backgroundColor:'#222'
		});
		
		var itemContainer = Ti.UI.createView({
			top:7,
			left:4,
			width:111,
			height:111,
			backgroundColor:'#222'
		});

		var imageView = Ti.UI.createImageView({
			image:f,
			top:3,
			left:3,
			width:105,
			height:105,
			preventDefaultImage:true
		});
		
		var title = truncateString(storyObj.title);
		var alabel = Ti.UI.createLabel({
			left:5,
			width:105-5-10,
			height:'auto',
			bottom:2,
			text:title,
			font:{fontSize:11,fontWeight:'bold'},
			color:'#fff'
			//			shadowColor:'#000',
			//			shadowOffset:{x:0,y:-1},
		});
		var labelWrapper = Ti.UI.createView({
			left:3,
			width:105,
			height: calcHeight(title),
			bottom:3,
			backgroundColor:'#111111',
			opacity:0.6
		});
		labelWrapper.add(alabel);

		itemContainer.add(imageView);
		itemContainer.add(labelWrapper);
		if (downLoadMgr.mType.VIDEO_TYPE === storyObj.type || downLoadMgr.mType.AUDIO_TYPE === storyObj.type ) {
			var play = Ti.UI.createImageView({
				image:'images/play.png',
				right:6,
				bottom:7,
				width:10,
				height:10
			});
			itemContainer.add(play);
		}
		/*		var animationProperties = {delay: 50, duration: 1000, opacity: 1.0};
 		imageView.animate(animationProperties, function() {
 		});*/
 		
 		view.container = itemContainer;
 		view.add(itemContainer);
		return view;
	}
	
	function calcHeight(title) {
		var height = 'auto';
		if (Ti.Platform.osname === 'android') {
			if (title.length > 15) {
				height = 32;
			} else {
				height = 20;
			}
		}
		return height;		
	}
	
	function truncateString(str) {
		var maxlen = 27;
		var newstr = str;
		if(maxlen < newstr.length) {
			newstr = newstr.substring(0, maxlen) + '...';
		}
		return newstr;		
	}

	function makeMormonadRibbonObj(storyObj) {
		var f = lds.io.getPathForFile(storyObj.thumb, storyObj.id);
		if(null === f) {
			f = 'images/med-placeholder.png';
		}
		
		var view = Ti.UI.createView({
			top:0,
			left:0,
			width:115,
			height:145,
			backgroundColor:'#222'
		});
				
		var imageView = Ti.UI.createImageView({
			image:f,
			top:3,
			left:3,
			width:105,
			height:135,
			preventDefaultImage:true
		});
		var title = truncateString(storyObj.title);
		var alabel = Ti.UI.createLabel({
			text:title,
			font:{fontSize:11,fontWeight:'bold'},
			color:'#fff',
			shadowColor:'#000',
			shadowOffset:{x:0,y:-1},
			right:2,
			left:2,
			bottom:2,
			height:'auto'
		});

		var labelWrapper = Ti.UI.createView({
			left:3,
			width:105,
			bottom:3,
			backgroundColor:'#111111',
			opacity:0.6,
			height:calcHeight(title)
		});
		labelWrapper.add(alabel);
		var itemContainer = Ti.UI.createView({
			top:7,
			left:4,
			width:111,
			height:141,
			backgroundColor:'#222'
		});
		itemContainer.add(imageView);
		itemContainer.add(labelWrapper);
		
		view.add(itemContainer);
		view.container = itemContainer;
		
		return view;
	}
	
	function connectClick(item, view)
	{
		view.addEventListener('click', function(e) {
			if (!item.isfeature) {
				view.container.backgroundColor = '#808080';				
			}
			if(downLoadMgr.mType.AUDIO_TYPE === item.type) {
				lds.ui.audioView.show(item.id);
			} else if (downLoadMgr.mType.MORMONAD_TYPE === item.type) {
				lds.ui.adView.show(item.id);
			} else if (Ti.Platform.osname == 'android' && downLoadMgr.mType.VIDEO_TYPE === item.type) {
				lds.ui.videoView.show(item.id);
			} else {
				lds.ui.articleView.show(item.id);
			}
			if (!item.isfeature) {
				setTimeout( function() {
					view.container.backgroundColor = '#222'
				}, 1000);				
			}
		});		
	}

	function insertResourceIntoRibbon(storyObj) {
		if (storyObj.isVisible) {
			if (storyObj.isfeature) {
				Ti.API.info('making feature item');
				var viewObj = makeFeaturedRibbonObj(storyObj);				
				lds.ui.mainView.featureRib().addView(viewObj);
				featureViews.push(viewObj);
			} else if (downLoadMgr.mType.VIDEO_TYPE === storyObj.type || downLoadMgr.mType.AUDIO_TYPE === storyObj.type || downLoadMgr.mType.ARTICLE_TYPE === storyObj.type) {
				Ti.API.info('making standard item'+ storyObj.type);
				var viewObj = makeStandardRibbonObj(storyObj);
				if(downLoadMgr.mType.AUDIO_TYPE === storyObj.type) {
					lds.ui.mainView.musicRib().add(viewObj);
				} else if (downLoadMgr.mType.VIDEO_TYPE === storyObj.type) {
					lds.ui.mainView.videoRib().add(viewObj);
				} else if (downLoadMgr.mType.ARTICLE_TYPE === storyObj.type) {
					lds.ui.mainView.artRib().add(viewObj);
				}
			} else if (downLoadMgr.mType.MORMONAD_TYPE === storyObj.type) {
				Ti.API.info('making mormon ad item');
				var viewObj = makeMormonadRibbonObj(storyObj);
				lds.ui.mainView.mormonadRib().add(viewObj);
			}
			
			connectClick(storyObj, viewObj);					
		}
	}

	return {
		loadContentIntoUI:loadContentIntoUI,
		clearUIRibbons:clearUIRibbons
	};
})();
//This global variable is a kludge to prevent two items being click at once
//There might be a better way to handle this, but for now it works
//set by the viewController on entry and cleared when the window or view is closed.
var g_processingClick = false;
//

