lds.net = {};
(function() {
	function isValidName(imagePath) {
		var pathLength = imagePath.length;
		var lastDot = imagePath.lastIndexOf(".");
		var fileType = imagePath.substring(lastDot,pathLength);
		if((fileType == ".gif") || (fileType == ".jpg") || (fileType == ".png") || (fileType == ".GIF") || (fileType == ".JPG") || (fileType == ".PNG") || (fileType == ".xml") || (fileType == ".json")) {
			return true;
		} else {
			Ti.API.info("We supports .JPG, .PNG, and .GIF image formats. Your file-type is " + fileType);
		}
		return false;
	}

	//mode = localonly, remoteonly, any
	//error codes	: 1 - Device not online
	//				: 2 - Bad File name
	//				: 3 - URL not finding Web Service
	//				: 4 - File not found local
	//				: 5 - File not found local and Device not online
	lds.net.get_remote_file = function( mode, fName, folder, url, fn_end, fn_progress ) {
		Ti.API.info('getting ' + mode + ' file - ' + folder + ' ' + fName);
		var fo = {file:fName, url:url, path: null, error: null};
		if ( 'remoteonly' === mode && !Titanium.Network.online ) {
			fo.error = 1;
			fo.error_desc = 'Device not online';
			if ( null != fn_end ) {
				fn_end(fo);
			}
			return;
		}
		if ( isValidName(fName) ) {
			var file;
			if (null != folder) {
				var d = lds.io.createContentFolder(folder);
				file = Titanium.Filesystem.getFile(d.nativePath, fName);
			} else {
				file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, fName);
				Ti.API.info(' file path for all.json:' + file.nativePath);
			}
			if ( 'localonly' === mode ) {
				if ( file.exists() ) {
					fo.path = file.nativePath;
				} else {
					fo.error = 4;
					fo.error_desc = 'File not found locally';
				}
				if ( null != fn_end ) {
					fn_end(fo);
				}
				return;
			}
			if ( 'any' === mode && file.exists() ) {
				fo.path = file.nativePath;
				if ( null != fn_end ) {
					fn_end(fo);
				}
			} else {
				if ( ('any' === mode || 'remoteonly' === mode) && Titanium.Network.online ) {
					var c = Titanium.Network.createHTTPClient();
					c.setTimeout(30000);
					c.onload = function() {
						if (c.status == 200 ) {
							var f = Titanium.Filesystem.getFile(file.nativePath);
							f.write(this.responseData);
							fo.path = file.nativePath;
						} else {
							Ti.API.info('Web Service Error' + url);
							fo.error = 3; // to set some errors codes
							fo.error_desc = 'Web Service Error';
						}
						if ( null != fn_end ) {
							fn_end(fo);
						}
					};
					c.ondatastream = function(e) {
						if ( null != fn_progress ) {
							fn_progress(e.progress);
						};
					};
					c.onerror = function(e) {
						Ti.API.info('Timeout on file_get - ' + fName + ' ');
						fo.error = 3;
						fo.desc = 'Error connecting to service';
						if ( null != fn_end ) {
							fn_end(fo);
						}
					};
					c.open('GET',url);
					c.send();
				} else {
					fo.error = 1;
					fo.error_desc = 'Not Online Error';
					if ( null != fn_end ) {
						fn_end(fo);
					}
				}
			}
		} else {  // not a valid file name
			Ti.API.info('not valid name for file:' + fo.file);
			fo.error = 2;
			fo.error_desc = 'bad file name';
			if ( null != fn_end ) {
				fn_end(fo);
			}
		}
	};
})();
