lds.ui.shareView = {};
(function() {

	var w,v,bbtn,sbtn,art_data,fbBtn;
	var isShowing = false;
	var mask;
	Titanium.Facebook.addEventListener('login', fbLoggedInEvent);
	Titanium.Facebook.addEventListener('logout', fbLoggedOutEvent);
	Titanium.Facebook.appid = '192676277419886';
	Titanium.Facebook.permissions = ['publish_stream']; // Permissions your app needs
	Titanium.Facebook.forceDialogAuth = true;

	function fbLoggedInEvent(e) {
		if (e.success) {
			if (Ti.Platform.osname !== 'android') {
				fbBtn.enabled = true;				
			}
			
			//			fbPost()
		} else if (e.error) {
			lds.ui.alert('Facebook Request','An error occurred. Please try again later.');
		} else if (e.cancelled) {
			lds.ui.alert('Facebook Request','Request was canceled');
		}
	}

	function fbLoggedOutEvent(e) {
		if (Ti.Platform.osname !== 'android') {
			fbBtn.enabled = false;
		}
	}

	function fbPost(assetData) {
		var imgUrl = "";
		var imgWanted = (assetData.ResourceType === downLoadMgr.mType.MORMONAD_TYPE) ? assetData.MediumImageUri : assetData.SmallImageUri;
		for(var i=0;i<assetData.AssetUris.length;i++) {
			if(assetData.AssetUris[i].indexOf(imgWanted) !== -1) {
				imgUrl = assetData.AssetUris[i];
				break;
			}
		}
		var url = assetData.ArticleUri;
		url += ( -1 < url.indexOf('?') ) ? '&cid=' : '?cid=';
		url += Titanium.Platform.osname;

		var data = {
			link:  			url,
			name: 			assetData.Title,
			message: 		"",
			caption: 		"LDS Youth mobile app",
			picture: 		imgUrl,
			description: 	assetData.Description
		};
		Titanium.Facebook.dialog("feed", data, function(e) {
			if (e.success) {
				Titanium.Analytics.featureEvent('Facebook Post',{id:assetData.ResourceId, type:assetData.ResourceType});
				//				alert("Success!  From FB: " + e.result);
				if (Ti.Platform.osname !== 'android') {
					cancel();
				}
			} else {
				if (e.error) {
					lds.ui.alert('Facebook Request','An error occurred. Please try again later.');
				} else if (e.cancelled) {
					lds.ui.alert('Facebook Request','Request was canceled');
				} else {
					lds.ui.alert('Facebook Request','Unkown result');
				}
			}
		});
	}

	function emailAsset(assetData) {
		try {
			if (Titanium.Network.online) {
				var emailDialog = Titanium.UI.createEmailDialog();
				emailDialog.setHtml(true);
				emailDialog.subject = "I want to share this with you.";
				var url = assetData.ArticleUri;
				url += ( -1 < url.indexOf('?') ) ? '&cid=' : '?cid=';
				url += Titanium.Platform.osname;
				emailDialog.messageBody = assetData.Description + '<br/><a href="' + url +'">'+ url +'<a/>';
				
				if (Ti.Platform.osname !== 'android') {
					emailDialog.setBarColor('#000');
				}

				emailDialog.addEventListener('complete', function(e) {
					if (e.result == emailDialog.SENT) {
						Titanium.Analytics.featureEvent('Email',{id:assetData.ResourceId, type:assetData.ResourceType});
						if (Ti.Platform.osname !== 'android') {
							cancel();							
						}
						if (Ti.Platform.osname != 'android') {
							// android doesn't give us useful result codes.
							// it anyway shows a toast.
							//		                lds.ui.alert('E-mail Request','Message sent.');
						}
					} else if (e.result == emailDialog.FAILED) {
						lds.ui.alert('E-mail Request',
						'Please check that your e-mail client is setup and configured.');
					} else if (e.result == emailDialog.SAVED) {
						alert('E-mail Request','Message has been saved.');
					} else {
						alert('Unknown Result', 'Result unknown for sending email. ' + e.error);
					}
				});
				emailDialog.open();
			} else {
				var alrt = Titanium.UI.createAlertDialog({
					title: 'No Internet Connection',
					message: 'You need to connect to the internet in order to be able to send your feedback. Thanks.'
				});
				alrt.show();
			}
		} catch (e) {
			Titanium.API.debug('>>> Error while showing the email dialog.' + e.message);
		}		
	}

	function emailClicked() {
		emailAsset(art_data);
	}
	
	function postToFacebookClicked() {
		fbPost(art_data);
	}

	function cancel() {
		_sh();
	}

	lds.ui.shareView.addAndroidMenu = function(assetId) {
		var activity = Ti.Android.currentActivity;
		activity.onCreateOptionsMenu = function (e) {
		    var menu = e.menu;
				
			var item1 = menu.add({title: 'E-mail'});
			//item1.setIcon('images/mail.png');
			item1.addEventListener('click', function(){
				var asset = lds.io.loadAssetFile(assetId);
				emailAsset(asset);
			});
			
			var item2 = menu.add({title: 'Post to Facebook'});
			//item2.setIcon('images/fb.png');
			item2.addEventListener('click', function(){	
				art_data = lds.io.loadAssetFile(assetId);
				Ti.Facebook.authorize();
				if (Ti.Facebook.loggedIn) {
					fbPost(art_data);
				}
			});
		}
	};

	lds.ui.shareView.showhide = function(win,backBtn,shareBtn,art) {
		if (false === Titanium.Network.online) {
			lds.ui.alert('Internet Connection',
			'Sharing requires a connection to the Internet.');
		} else {
			bbtn = backBtn;
			sbtn = shareBtn;
			w = win;
			art_data = art;
			_sh();
		}
	};
	function _sh() {
		sbtn.enabled = false;
		if(!isShowing) {
			bbtn.enabled = false;
			mask = Titanium.UI.createView({
				height:Titanium.Platform.displayCaps.platformHeight,
				width:Titanium.Platform.displayCaps.platformWidth,
				visible:true,
				backgroundColor:'#000',
				opacity:0.3
			});
			v = Titanium.UI.createView({
				backgroundGradient:
				{	type:'linear',
					colors:
					['#000','#ddd'],
					startPoint:
					{x:320,
						y:0},
					endPoint:
					{x:320,
						y:380},
					backFillStart: true
				},
				height:270,
				width:320,
				top:-380,
				right:0,
				anchorPoint:{x:1,y:0},
				visible:false,
				borderRadius:10,
				opacity:0
			});
			var shLabel = Ti.UI.createLabel({
				text:'Share this with others',
				font:{fontSize:18},
				color:'#fff',
				shadowColor:'#000',
				shadowOffset:{x:0,y:-1},
				top:10,
				width:320,
				height:'auto',
				textAlign:'center'
			});
			v.add(shLabel);

			var fb_postBtn_enabled = Titanium.Facebook.loggedIn;
			var fb_loginBtn = Titanium.Facebook.createLoginButton({
				'style':'wide',
				top:15+(52/2),
				width:75
			});
			v.add(fb_loginBtn);
			fbBtn = Titanium.UI.createButton({
				title:'Post to Facebook',
				height:50,
				width:220+52+10,
				top:85+(52/2)-25,
				left:20,
				enabled:fb_postBtn_enabled,
				backgroundImage:'images/BUTT_blu_off.png',
				backgroundSelectedImage:'images/BUTT_blu_on.png',
				backgroundDisabledImage: 'images/BUTT_drk_off.png'
			});
			v.add(fbBtn);
			fbBtn.addEventListener('click', postToFacebookClicked);

			var mlBtn = Titanium.UI.createButton({
				title:'E-mail',
				height:50,
				width:220+52+10,
				top:85+52+10+(52/2)-25,
				left:20,
				backgroundImage:'images/BUTT_blu_off.png',
				backgroundSelectedImage:'images/BUTT_blu_on.png',
				backgroundDisabledImage: 'images/BUTT_drk_off.png'
			});
			v.add(mlBtn);
			mlBtn.addEventListener('click', emailClicked);
			var cancelBtn = Titanium.UI.createButton({
				title:'Cancel',
				height:45,
				width:220+52+10,
				top:85+52+10+52+10+(52/2)-25,
				left:20,
				backgroundImage:'images/BUTT_red_off.png',
				backgroundSelectedImage:'images/BUTT_red_on.png',
				backgroundDisabledImage: 'images/BUTT_red_off.png'
			});
			v.add(cancelBtn);
			cancelBtn.addEventListener('click', cancel);

			w.add(mask);
			w.add(v);
			v.show();
			var a = Titanium.UI.createAnimation();
			a.top = 0;
			a.duration = 400;
			a.opacity = 1;
			a.addEventListener('complete', function() {
				//				sbtn.enabled = true;
			});
			v.animate(a);
			isShowing=true;
		} else {
			var a = Titanium.UI.createAnimation();
			a.top = -380;
			a.duration = 400;
			a.opacity = 0.4;
			a.addEventListener('complete', function() {
				w.remove(v);
				w.remove(mask);
				mask = null;
				v = null;
				bbtn.enabled = true;
				sbtn.enabled = true;
				w=null;
				bbtn = null;
				sbtn = null;
			});
			v.animate(a);
			isShowing = false;
		}
	}

})();
