lds.ui.videoView = (function() {
	
	function show(id) {
		if (g_processingClick == false) {
			var art = lds.io.loadAssetFile(id);
			var url = art.VideoUri;
			if(url) {
				url += ( -1 < url.indexOf('?') ) ? '&cid=' : '?cid=';
				url += Titanium.Platform.osname;
			}	
					
			var imgPath = lds.io.getPathForFile(art.LargeImageUri,id);
			var artPath = lds.io.getPathForContentFolder(id);
			if( "" === imgPath ) {
				imgPath = 'images/large-placeholder.png';
			}
			var bylines = "";

			for (var i=0;i < art.Bylines.length;i++) {
				if(0<i) {
					bylines += '<BR>';
				}
				bylines += art.Bylines[i];
			};
			
			var win = Ti.UI.createWindow({
				title:'VIDEO',
				backgroundColor:'#282828',
				barColor:'#000',
				fullscreen: false,
				layout:'vertical',
				orientationModes : [ Titanium.UI.PORTRAIT,Titanium.UI.LANDSCAPE_LEFT,Titanium.UI.LANDSCAPE_RIGHT ]
				//				url:'article.js'
			});
			
			win.addEventListener('android:back',function(){
				win.close();
				g_processingClick = false;
				return false;
			});
						
			var heading = Ti.UI.createLabel({
				color: '#fff',
				text: art.Title,
				font: {fontSize:20,fontWeight:'bold'},
				left: 10,
				top: 10
			});
			win.add(heading);
			
			var byline = Ti.UI.createLabel({
				text: bylines
			});
			win.add(byline);
			
			var imageView = Ti.UI.createView({
				layout:'absolute'
			});
			
			var image = Ti.UI.createImageView({
				image: imgPath
			});
			imageView.add(image);
			var playback = Ti.UI.createImageView({
				image: 'images/playback.png',
				bottom: 20,
				left: 20,
				width: 40,
				height: 40
			});
			imageView.add(playback);
			
			
			imageView.addEventListener('click', function() {
				var activeMovie = Titanium.Media.createVideoPlayer({
					url: url,
					backgroundColor:'#111',
					movieControlMode:Titanium.Media.VIDEO_CONTROL_DEFAULT,
					scalingMode:Titanium.Media.VIDEO_SCALING_ASPECT_FIT,
					fullscreen:true
				});
				activeMovie.addEventListener('complete', function() {
					activeMovie.hide();
				});
				activeMovie.play();
			});
			
			win.add(imageView);
			
			var content = Ti.UI.createWebView({
				html: '<html><head><meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no" /></head><body style="color:white;">' +  art.Content.replace(/\[teaser:\d+-eng\]/gi, '') + '</body></html>',
				backgroundColor:'#282828',
				width:'auto',
				height:'auto',
				scalesPageToFit: false,
				color: '#fff'
			});
			win.add(content);
			
			
			win.open();

			if (Ti.Platform.osname === 'android') {
				lds.ui.shareView.addAndroidMenu(id);
			}			

		}
	}
	
	
	return {
		show: show
	};
})();
